## psi 1.5+dfsg1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1.0)
if(NOT CMAKE_BUILD_TYPE)
	set(CMAKE_BUILD_TYPE "Release" CACHE STRING "")
endif()

#Common options
option( BUNDLED_IRIS "Build iris library bundled" ON )
option( ONLY_PLUGINS "Build psi-plus plugins only" OFF )
option( USE_HUNSPELL "Build psi-plus with hunspell spellcheck" ON )
option( USE_ENCHANT "Build psi-plus with enchant spellcheck" OFF )
option( USE_QT5 "Use Qt5 to build psi-plus" ON )
option( ENABLE_PLUGINS "Enable plugins" OFF )
option( ENABLE_WEBKIT "Enable webkit support" ON )
option( USE_WEBENGINE "Use WebEngine support instead of Webkit" OFF )
option( USE_CCACHE "Use ccache utility if found" ON )
option( VERBOSE_PROGRAM_NAME "Verbose output binary name" OFF ) #Experimental
#Windows or MXE only
option( USE_MXE "Use MXE cross-compilation" OFF )
option( ENABLE_PORTABLE "Create portable version of Psi+ in win32" OFF)
option( PRODUCTION "Build production version" OFF )
#Iris options
option( USE_QJDNS "Use qjdns/jdns library. Disabled by default for Qt5" OFF )
option( SEPARATE_QJDNS "Build qjdns as separate lib" OFF )


set( IS_PSIPLUS ON CACHE BOOL "Build Psi+ client")

if(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/src/widgets/psiwindowheader.cpp")
	message(STATUS "Psi+ features - FOUND")
	set(IS_PSIPLUS ON)
	project(psi-plus)
else()
	message(STATUS "Psi+ features - NOT FOUND")
	set(IS_PSIPLUS OFF)
	project(psi)
endif()

set(GLOBAL_DEPENDS_DEBUG_MODE ON)

set( CMAKE_MODULE_PATH "${CMAKE_MODULE_PATH}" "${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules" )

set( ENABLE_SQL OFF CACHE BOOL "Enable SQL history support")

if(ENABLE_WEBKIT)
	add_definitions(
		-DWEBKIT
	)
	if(USE_QT5)
		find_package( Qt5Core REQUIRED )
		find_package( Qt5 COMPONENTS WebEngine QUIET )
		if(${Qt5Core_VERSION} VERSION_GREATER 5.6.0)
			if( Qt5WebEngine_FOUND )
				set( USE_WEBENGINE ON )
				add_definitions(
					-DWEBENGINE=1
				)
				message(STATUS "QtWebEngine - enabled")
			else()
				set( USE_WEBENGINE OFF )
			endif()
		endif()
	endif()
	message(STATUS "Webkit - enabled")
endif()


if(EXISTS "${PROJECT_SOURCE_DIR}/src/historyimp.cpp")
	message(STATUS "SQL history - enabled")
	set(ENABLE_SQL ON)
else()
	set(ENABLE_SQL OFF)
endif()

if("${CMAKE_BUILD_TYPE}" STREQUAL "Debug" OR ("${CMAKE_BUILD_TYPE}" STREQUAL "RelWithDebInfo"))
	set(ISDEBUG ON)
endif()

if(WIN32)
	if(MSVC)
		set(BUILD_ARCH "win64" CACHE STRING "CPU architecture win32/win64")
		set(SDK_PATH "e:/build/msvc2015-root" CACHE STRING "Path to SDK")
	else()
		set(BUILD_ARCH "i386" CACHE STRING "CPU architecture i386/x86_64")
		set(SDK_PATH "e:/build/psisdk" CACHE STRING "Path to SDK")
		set(SDK_SUFFIX ${BUILD_ARCH})
		#temporary Qt5
		if(USE_QT5)
			set(SDK_PATH "${SDK_PATH}/Qt5")
			set(SDK_SUFFIX "")
		endif()
		set(LIBGCRYPT_SDK "libgcrypt")
		set(LIBGPGERROR_SDK "libgpg-error")
	endif()
	#autodetect 64bit architecture
	if(CMAKE_SIZEOF_VOID_P MATCHES "8")
		if(MSVC)
			set(BUILD_ARCH "win64")
		else()
			set(BUILD_ARCH "x86_64")
		endif()
	endif()
	message(STATUS "Detecting build architecture: ${BUILD_ARCH} detected")
	if(EXISTS "${SDK_PATH}")
		if(MSVC)
			set(QCA_DIR "${SDK_PATH}/" CACHE STRING "Path to QCA")
			set(IDN_ROOT "${SDK_PATH}/" CACHE STRING "Path to IDN library")
			set(HUNSPELL_ROOT "${SDK_PATH}/" CACHE STRING "Path to hunspell library")
			set(LIBGCRYPT_ROOT "${SDK_PATH}/" CACHE STRING "Path to libgcrypt library")
			set(LIBGPGERROR_ROOT "${SDK_PATH}/" CACHE STRING "Path to libgpg-error library")
			set(LIBOTR_ROOT "${SDK_PATH}/" CACHE STRING "Path to libotr library")
			set(LIBTIDY_ROOT "${SDK_PATH}/" CACHE STRING "Path to libtidy library")
			set(ZLIB_ROOT "${SDK_PATH}/" CACHE STRING "Path to zlib")
		else()
			set(QCA_DIR "${SDK_PATH}/qca/${SDK_SUFFIX}/" CACHE STRING "Path to QCA")
			set(IDN_ROOT "${SDK_PATH}/libidn/${SDK_SUFFIX}/" CACHE STRING "Path to IDN library")
			set(HUNSPELL_ROOT "${SDK_PATH}/hunspell/${SDK_SUFFIX}/" CACHE STRING "Path to hunspell library")
			set(LIBGCRYPT_ROOT "${SDK_PATH}/${LIBGCRYPT_SDK}/${SDK_SUFFIX}/" CACHE STRING "Path to libgcrypt library")
			set(LIBGPGERROR_ROOT "${SDK_PATH}/${LIBGPGERROR_SDK}/${SDK_SUFFIX}/" CACHE STRING "Path to libgpg-error library")
			set(LIBOTR_ROOT "${SDK_PATH}/libotr/${SDK_SUFFIX}/" CACHE STRING "Path to libotr library")
			set(LIBTIDY_ROOT "${SDK_PATH}/libtidy/${SDK_SUFFIX}/" CACHE STRING "Path to libtidy library")
			set(QJSON_ROOT "${SDK_PATH}/qjson/${SDK_SUFFIX}" CACHE STRING "Path to qjson library")
			set(ZLIB_ROOT "${SDK_PATH}/zlib/${SDK_SUFFIX}/" CACHE STRING "Path to zlib")
			set(QJDNS_DIR "${SDK_PATH}/qjdns/${SDK_SUFFIX}/" CACHE STRING "Path to qjdns")
			set(GST_SDK "${SDK_PATH}/gstbundle/${SDK_SUFFIX}/" CACHE STRING "Path to gstreamer SDK")
			set(PSIMEDIA_DIR "${SDK_PATH}/psimedia/${SDK_SUFFIX}/" CACHE STRING "Path to psimedia plugin")
		endif()
	else()
		message(WARNING "Psi SDK not found at ${SDK_PATH}. Please set SDK_PATH variable or add Psi dependencies to PATH system environmet variable")
	endif()
	set(PLUGINS_PATH "/plugins" CACHE STRING "Install suffix for plugins")
endif()

set(VER_FILE ${PROJECT_SOURCE_DIR}/version)
if(EXISTS "${VER_FILE}")
	message(STATUS "Found Psi version file: ${VER_FILE}")
	file(STRINGS "${VER_FILE}" VER_LINES)
	if(IS_PSIPLUS)
		string(REGEX MATCHALL "^([0-9]+\\.[0-9]+\\.[0-9]+)+.+Psi:([a-fA-F0-9]+)+.+Psi\\+:([a-fA-F0-9]+)+" VER_LINE_A ${VER_LINES})
		if(${CMAKE_MATCH_COUNT} EQUAL 3)
			if(CMAKE_MATCH_1)
				set(APP_VERSION ${CMAKE_MATCH_1})
			endif()
			if(CMAKE_MATCH_2)
				set(PSI_REVISION ${CMAKE_MATCH_2})
			endif()
			if(CMAKE_MATCH_3)
				set(PSI_PLUS_REVISION ${CMAKE_MATCH_3})
			endif()
		endif()
		if(APP_VERSION)
			message(STATUS "Psi version found: ${APP_VERSION}")
		elseif(NOT APP_VERSION AND (NOT PSI_VERSION) )
			message(WARNING "Psi+ version not found! 1.0-dev version will be set")
			set(APP_VERSION "1.0")
		endif()
		if(PSI_REVISION)
			message(STATUS "Psi revision found: ${PSI_REVISION}")
		endif()
		if(PSI_PLUS_REVISION)
			message(STATUS "Psi+ revision found: ${PSI_PLUS_REVISION}")
		endif()
	else()
		string(REGEX MATCH "^[0-9]+\\.[0-9]+" VER_LINE ${VER_LINES})
		if (VER_LINE)
			set(APP_VERSION ${VER_LINE})
			message(STATUS "Psi version found: ${VER_LINE}")
		elseif( NOT PSI_VERSION )
			message(WARNING "Psi version not found! 1.0-dev version will be set")
			set(APP_VERSION "1.0")
		endif()
	endif()
endif()

if( IS_PSIPLUS AND ( APP_VERSION AND ( PSI_REVISION AND PSI_PLUS_REVISION ) ) )
	set(PSIPLUS_VERSION_OBTAINED ON)
elseif( NOT IS_PSIPLUS AND APP_VERSION )
	set(PSI_VERSION_OBTAINED ON)
endif()

# Define LINUX on Linux like as WIN32 on Windows and APPLE on Mac OS X
if(UNIX AND NOT APPLE)
	set(LINUX ON)
	add_definitions(
		-DHAVE_X11
		-DHAVE_FREEDESKTOP
		-DAPP_PREFIX=${CMAKE_INSTALL_PREFIX}
		-DAPP_BIN_NAME=${PROJECT_NAME}
	)
endif()

#Detect MXE cross-compilation
if( (CMAKE_CROSSCOMPILING) AND (DEFINED MSYS) )
	message(STATUS "MXE environment detected")
	set(USE_MXE ON)
endif()

# Qt dependencies make building very slow
# Track only .h files
include_regular_expression("^.*\\.h$")

# Put executable in build root dir
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/psi" )

if(APPLE)
	# Force Qt5 build on Mac OS X. Qt4 is not supported
	set(USE_QT5 ON)
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-overloaded-virtual")
else()
# Enable all warnings
	if(NOT MSVC)
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -Wall -Wextra")
		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Wextra")
	else()
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /MP")
		if(NOT ISDEBUG)
			set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} /LTCG")
			set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} /LTCG")
		endif()
		add_definitions(-DNOMINMAX)
	endif()
endif()

message(STATUS "CXX flags: ${CMAKE_CXX_FLAGS}")
message(STATUS "C flags: ${CMAKE_C_FLAGS}")

if(ISDEBUG)
	set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -O0")
	set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -O0")
	if(MSVC)
		set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} /INCREMENT:NO /MANIFEST:NO")
		set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} /INCREMENT:NO /MANIFEST:NO")
		set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} /MTd")
	endif()
	message(STATUS "CXX debug flags: ${CMAKE_CXX_FLAGS_DEBUG}")
	message(STATUS "C debug flags: ${CMAKE_C_FLAGS_DEBUG}")
endif()

if(USE_QT5)
	option( QT4_BUILD "Build with Qt4 support" OFF )
else()
	set( USE_QT5 OFF)
	option( QT4_BUILD "Build with Qt4 support" ON )
endif()

if(NOT WIN32 AND PRODUCTION)
	message(WARNING "PRODUCTION flag only for Windows OS")
	set(PRODUCTION OFF)
endif()

if(NOT WIN32 AND ENABLE_PORTABLE)
	message(WARNING "Portable version creation possible only for Windows OS")
	set(ENABLE_PORTABLE OFF)
elseif(WIN32 AND ENABLE_PORTABLE)
	set(PRODUCTION ON)
endif()

# Copy a list of files from one directory to another. Only full paths.
function(copy SOURCE DEST TARGET)
	if(EXISTS ${SOURCE})
		set(OUT_TARGET_FILE "${CMAKE_BINARY_DIR}/${TARGET}.cmake")

		string(REGEX REPLACE "\\\\+" "/" DEST "${DEST}")
		string(REGEX REPLACE "\\\\+" "/" SOURCE "${SOURCE}")

		if(NOT TARGET ${TARGET})
			file(REMOVE "${OUT_TARGET_FILE}")
			add_custom_target(${TARGET} COMMAND ${CMAKE_COMMAND} -P "${OUT_TARGET_FILE}")
		endif()

		if(IS_DIRECTORY ${SOURCE})
			# copy directory
			file(GLOB_RECURSE FILES "${SOURCE}/*")
			get_filename_component(SOURCE_DIR_NAME ${SOURCE} NAME)

			foreach(FILE ${FILES})
				file(RELATIVE_PATH REL_PATH ${SOURCE} ${FILE})
				set(REL_PATH "${SOURCE_DIR_NAME}/${REL_PATH}")
				get_filename_component(REL_PATH ${REL_PATH} DIRECTORY)
				set(DESTIN "${DEST}/${REL_PATH}")

				string(REGEX REPLACE "/+" "/" DESTIN ${DESTIN})
				string(REGEX REPLACE "/+" "/" FILE ${FILE})

				file(APPEND
					"${OUT_TARGET_FILE}"
					"file(INSTALL \"${FILE}\" DESTINATION \"${DESTIN}\" USE_SOURCE_PERMISSIONS)\n")
			endforeach()
		else()
			string(REPLACE "//" "/" DEST ${DEST})
			if(DEST MATCHES "/$")
				set(DIR "${DEST}")
				string(REGEX REPLACE "^(.+)/$" "\\1" DIR ${DIR})
			else()
				# need to copy and rename
				get_filename_component(DIR ${DEST} DIRECTORY)
				get_filename_component(FILENAME ${DEST} NAME)
				get_filename_component(SOURCE_FILENAME ${SOURCE} NAME)
			endif()
			file(APPEND
				"${OUT_TARGET_FILE}"
				"file(INSTALL \"${SOURCE}\" DESTINATION \"${DIR}\" USE_SOURCE_PERMISSIONS)\n")
			if(DEFINED FILENAME)
				file(APPEND
					"${OUT_TARGET_FILE}"
					"file(RENAME \"${DIR}/${SOURCE_FILENAME}\" \"${DIR}/${FILENAME}\")\n")
			endif()
		endif()
	endif()
endfunction()

if(USE_MXE)
	set(USE_CCACHE OFF)
endif()

if(USE_CCACHE)
	# Configure CCache if available
	find_program(CCACHE_PATH ccache DOC "Path to ccache")
	if(CCACHE_PATH)
		message(STATUS "Found ccache at ${CCACHE_PATH}")
		set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE ${CCACHE_PATH})
		set_property(GLOBAL PROPERTY RULE_LAUNCH_LINK ${CCACHE_PATH})
	endif()
endif()


if(NOT ONLY_PLUGINS)
	if( USE_WEBENGINE )
		add_subdirectory( 3rdparty )
	endif()
	if( ${BUNDLED_IRIS} )
		add_subdirectory( iris )
	else( ${BUNDLED_IRIS} )
		find_package( Iris REQUIRED )
		include_directories(${Iris_INCLUDE_DIR})
	endif( ${BUNDLED_IRIS} )
	set( iris_LIB iris )

	add_subdirectory(src)
else()
	set(ENABLE_PLUGINS ON)
	add_subdirectory(src/plugins)
endif()

=== 3rdparty/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1.0)

if(NOT CMAKE_BUILD_TYPE)
	set(CMAKE_BUILD_TYPE "Release")
endif()

project(qhttp)

add_definitions(
	-DQHTTP_MEMORY_LOG=0
)
if(WIN32)
	add_definitions(
		-D_WINDOWS
		-DWIN32_LEAN_AND_MEAN
		-DNOMINMAX
		-DQHTTP_EXPORT
	)
endif()

include_directories(
	.
	./qhttp/src
	./qhttp/src/private
	./http-parser
)

find_package(Qt5 REQUIRED Core Network)

set(http_parser_srcs
	http-parser/http_parser.c
)

set(http_parser_hdrs
	http-parser/http_parser.h
)

set(qhttp_srcs
	qhttp/src/qhttpabstracts.cpp
	qhttp/src/qhttpserverconnection.cpp
	qhttp/src/qhttpserver.cpp
	qhttp/src/qhttpserverrequest.cpp
	qhttp/src/qhttpserverresponse.cpp

)

set(qhttp_hdrs
	qhttp/src/qhttpfwd.hpp
	qhttp/src/qhttpabstracts.hpp
	qhttp/src/qhttpserverconnection.hpp
	qhttp/src/qhttpserver.hpp
	qhttp/src/qhttpserverrequest.hpp
	qhttp/src/qhttpserverresponse.hpp

)

set(qhttp_priv_hdrs
	qhttp/src/private/httpparser.hxx
	qhttp/src/private/qhttpclient_private.hpp
	qhttp/src/private/qhttpserver_private.hpp
	qhttp/src/private/httpreader.hxx
	qhttp/src/private/qhttpclientrequest_private.hpp
	qhttp/src/private/qhttpserverrequest_private.hpp
	qhttp/src/private/httpwriter.hxx
	qhttp/src/private/qhttpclientresponse_private.hpp
	qhttp/src/private/qhttpserverresponse_private.hpp
	qhttp/src/private/qhttpbase.hpp
	qhttp/src/private/qhttpserverconnection_private.hpp
	qhttp/src/private/qsocket.hpp
)

qt5_wrap_cpp(MOCS
	qhttp/src/qhttpabstracts.hpp
	qhttp/src/qhttpserverconnection.hpp
	qhttp/src/qhttpserver.hpp
	qhttp/src/qhttpserverrequest.hpp
	qhttp/src/qhttpserverresponse.hpp
)

add_library(qhttp
	STATIC
	${http_parser_srcs}
	${http_parser_hdrs}
	${qhttp_srcs}
	${MOCS}
)

set_property(TARGET qhttp PROPERTY CXX_STANDARD 14)
set_property(TARGET qhttp PROPERTY CXX_STANDARD_REQUIRED ON)

target_link_libraries(qhttp Qt5::Core Qt5::Network)
target_include_directories(qhttp
	PUBLIC
	./qhttp/src
	./qhttp/src/private
	${CMAKE_CURRENT_SOURCE_DIR}
	${CMAKE_CURRENT_BINARY_DIR}
)

=== iris/CMakeLists.txt ===
if(NOT CMAKE_BUILD_TYPE)
	set(CMAKE_BUILD_TYPE "Release")
endif()

project(iris)
cmake_minimum_required(VERSION 3.1.0)

set( IRIS_LIB_VERSION_MAJOR 1 )
set( IRIS_LIB_VERSION_MINOR 0 )
set( IRIS_LIB_VERSION_PATCH 0 )
set( IRIS_LIB_VERSION_STRING
	${IRIS_LIB_VERSION_MAJOR}.${IRIS_LIB_VERSION_MINOR}.${IRIS_LIB_VERSION_PATCH}
	)

set( CMAKE_MODULE_PATH
	"${CMAKE_MODULE_PATH}"
	"${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules"
	"${CMAKE_CURRENT_SOURCE_DIR}/../cmake/modules"
	"${PROJECT_SOURCE_DIR}/cmake/modules"
	"${PROJECT_SOURCE_DIR}/../cmake/modules"
	)

option( USE_QJDNS "Use qjdns/jdns library. Disabled by default for Qt5" OFF )
option( SEPARATE_QJDNS "Build qjdns with iris library" OFF )

include_directories(${PROJECT_SOURCE_DIR} ${PROJECT_BINARY_DIR})
include_directories(include/iris)

set(CMAKE_AUTOMOC OFF)

if(APPLE)
	# Force Qt5 build on Mac OS X. Qt4 is not supported
	set(USE_QT5 ON)
endif()

if(USE_QT5)
	find_package(Qt5 COMPONENTS Core Gui Xml Network REQUIRED)
	set(Qca_SUFFIX "-qt5")
	macro(qt4_generate_moc)
		qt5_generate_moc(${ARGN})
	endmacro()

	add_definitions(-DHAVE_QT5)
	if(USE_QJDNS)
		message(WARNING "USE_QJDNS flag is enabled with Qt5. If you have problems with connection please disable this flag")
	endif()
else()
	find_package(Qt4 COMPONENTS QtCore QtGui QtNetwork QtXml REQUIRED)
	include(${QT_USE_FILE})
	set(USE_QJDNS ON)
endif()

if(USE_QJDNS)
	add_definitions(-DNEED_JDNS)
endif()

find_package(Qca REQUIRED)
set(QCA_INCLUDES ${Qca_INCLUDE_DIR})
set(qca_LIB ${Qca_LIBRARY})

include_directories(
	${QCA_INCLUDES}
)

macro(qt_wrap_cpp)
	set(_SOURCES ${ARGN})
	list(REMOVE_AT _SOURCES 0)
	foreach(SOURCE ${_SOURCES})
		if(SOURCE MATCHES "^(.*/|)([^/.]+)\\.h$")
			set(DEST "moc_${CMAKE_MATCH_2}.cpp")
			qt4_generate_moc(${SOURCE} ${DEST})
			list(APPEND ${ARGV0} ${DEST})
		elseif(SOURCE MATCHES "^(.*/|)([^/.]+)\\.cpp$")
			set(DEST "${CMAKE_MATCH_2}.moc")
			qt4_generate_moc(${SOURCE} ${DEST})
			list(APPEND ${ARGV0} ${DEST})
		else()
			message(WARNING "Wrong source ${SOURCE}")
		endif()
	endforeach()
	unset(_SOURCES)
endmacro()

if(NOT USE_QJDNS AND SEPARATE_QJDNS)
	message(WARNING "SEPARATE_QJDNS flag enabled, but USE_QJDNS flag disabled. Both flags will be disabled")
	set(SEPARATE_QJDNS OFF)
endif()

if(USE_QJDNS AND (NOT SEPARATE_QJDNS))
	add_definitions(-DJDNS_STATIC)
	set(QJDns_LIBRARY qjdns)
	include_directories(
		src/jdns/include/jdns
		)
	set(jdns_SRCS
		src/jdns/src/jdns/jdns.c
		src/jdns/src/jdns/jdns_mdnsd.c
		src/jdns/src/jdns/jdns_packet.c
		src/jdns/src/jdns/jdns_sys.c
		src/jdns/src/jdns/jdns_util.c
		)
	set(jdns_PUBLIC_HEADERS
		src/jdns/include/jdns/jdns.h
		src/jdns/include/jdns/jdns_export.h
		)
	set(jdns_HEADERS
		src/jdns/src/jdns/jdns_packet.h
		src/jdns/src/jdns/jdns_mdnsd.h
		src/jdns/src/jdns/jdns_p.h
		)
	add_library(jdns STATIC ${jdns_SRCS} ${jdns_HEADERS} ${jdns_PUBLIC_HEADERS})
	if(WIN32)
		target_link_libraries(jdns ws2_32 advapi32)
	endif()
	set(qjdns_MOC_HDRS
		src/jdns/include/jdns/qjdns.h
		src/jdns/include/jdns/qjdnsshared.h
		src/jdns/src/qjdns/qjdns_p.h
		src/jdns/src/qjdns/qjdnsshared_p.h
		)

	qt_wrap_cpp(qjdns_MOC_SRCS ${qjdns_MOC_HDRS})

	set(qjdns_SRCS
		src/jdns/src/qjdns/qjdns.cpp
		src/jdns/src/qjdns/qjdns_sock.cpp
		src/jdns/src/qjdns/qjdnsshared.cpp
		)

	set(qjdns_PUBLIC_HEADERS
		src/jdns/include/jdns/qjdns.h
		src/jdns/include/jdns/qjdnsshared.h
		)
	set(qjdns_HEADERS
		src/jdns/src/qjdns/qjdns_sock.h
		)
	add_library(${QJDns_LIBRARY} STATIC ${qjdns_SRCS} ${qjdns_MOC_SRCS} ${qjdns_MOC_HDRS} ${qjdns_PUBLIC_HEADERS})
	if(USE_QT5)
		target_link_libraries(${QJDns_LIBRARY} Qt5::Core Qt5::Network)
	else()
		target_link_libraries(${QJDns_LIBRARY} ${QT_LIBRARIES})
	endif()
	target_link_libraries(${QJDns_LIBRARY} jdns)
elseif(USE_QJDNS)
	if(USE_QT5)
		set(QJDns_SUFFIX -qt5)
	else()
		set(QJDns_SUFFIX -qt4)
	endif()
	find_package(QJDns REQUIRED)
	set(QJDns_LIBRARY ${QJDns_LIBRARY} PARENT_SCOPE)
	include_directories( ${QJDns_INCLUDE_DIR} )
endif()

find_package(IDN REQUIRED)

add_definitions(-DIRISNET_STATIC)

add_subdirectory(src/irisnet)
add_subdirectory(src/xmpp)

=== mac/Makefile ===
#
# Build file for packaging Psi/Mac.
#
# The DMG packager looks for a template.dmg.bz2 for using as its 
# DMG template. If it doesn't find one, it generates a clean one.
#
# If you create a DMG template, you should make one containing all
# the files listed in $(FILES) below, and arrange everything to suit
# your style. The contents of the files themselves does not matter, so
# they can be empty. 
#
# Parameters:
#	* BUILD: Set this to 'no' if you do not want to build the source tree or
#		check dependencies of the 'disk' dir when building the DMG.
#
# Remko Troncon 
# http://el-tramo.be
#

# Change these according to your own setup
QCADIR=/usr/local
GROWLDIR=/Library/Frameworks
SPARKLEDIR=/Library/Frameworks
PSI_DIR=..

EXECUTABLE_NAME=psi
NAME=Psi
VOLUME_NAME=$(NAME)
VERSION=0.15-devel_$(shell date +"%Y%m%d")
#VERSION=0.15

APPFILE_NAME=Psi.app
FILES=$(APPFILE_NAME)
DISK_DIR=disk
ifneq ($(BUILD),no)
DISK_FILES=$(foreach f,$(FILES), $(addprefix $(DISK_DIR)/,$(f)))
endif
MASTER_DMG=$(NAME)-$(VERSION).dmg


# Other variables
QT_FRAMEWORK_VERSION=4
QT_FRAMEWORKS=QtCore QtXml QtNetwork QtGui QtSql QtSvg
QT_PLUGINS=imageformats/libqjpeg.dylib imageformats/libqgif.dylib

# The rules
.PHONY: buildall
all: build-psi $(DISK_FILES)

.PHONY: dmg
dmg: build-psi $(DISK_FILES) $(MASTER_DMG)

# Cleanup
.PHONY: clean
clean: clean-dmg
	-rm -rf $(DISK_DIR)

# Help
.PHONY: help
help:
	@echo "Usage:"
	@echo "    make : Build a distributable binary in $(DISK_DIR)/"
	@echo "    make dmg : Build a DMG disk image"

# Building the main source tree
.PHONY: build-psi
ifneq ($(BUILD),no)
build-psi:
	@echo
	@echo --------------------- Building Source Tree --------------------
	$(MAKE) -C $(PSI_DIR)
	@echo
else
build-psi:
endif


################################################################################
# Generation of the final files
################################################################################

# The binary
$(DISK_DIR)/$(APPFILE_NAME): $(PSI_DIR)/src/$(EXECUTABLE_NAME).app
	@echo
	@echo --------------------- Packaging Binary --------------------
	rm -rf "$@"
	ditto -rsrc "$<" "$@"
	mkdir -p "$@/Contents/Frameworks"
	-ditto -rsrc "$(GROWLDIR)/Growl.framework" "$@/Contents/Frameworks/Growl.framework"
	-ditto -rsrc "$(SPARKLEDIR)/Sparkle.framework" "$@/Contents/Frameworks/Sparkle.framework"
	#strip "$@/Contents/MacOS/$(EXECUTABLE_NAME)"
	#
	#@echo
	#@echo Installing QCA ...
	#cp -f "$(QCADIR)/lib/libqca.2.dylib" "$@/Contents/Frameworks/"
	#install_name_tool -id "@executable_path/../Frameworks/libqca.2.dylib" "$@/Contents/Frameworks/libqca.2.dylib"
	#install_name_tool -change "libqca.2.dylib" "@executable_path/../Frameworks/libqca.2.dylib" "$@/Contents/MacOS/$(EXECUTABLE_NAME)"
	#install_name_tool -change "$(QCADIR)/lib/libqca.2.dylib" "@executable_path/../Frameworks/libqca.2.dylib" "$@/Contents/MacOS/$(EXECUTABLE_NAME)"
	#mkdir -p "$@/Contents/Resources/crypto"
	#cp -f "$(QTDIR)/plugins/crypto/libqca-openssl.dylib" "$@/Contents/Resources/crypto/"
	#install_name_tool -change "$(QCADIR)/lib/libqca.2.dylib" "@executable_path/../Frameworks/libqca.2.dylib" "$@/Contents/Resources/crypto/libqca-openssl.dylib"
	#install_name_tool -change "libqca.2.dylib" "@executable_path/../Frameworks/libqca.2.dylib" "$@/Contents/Resources/crypto/libqca-openssl.dylib"
	for f in $(QT_PLUGINS); do \
		mkdir -p "$@/Contents/Plugins/`dirname $$f`"; \
		cp -f "$(QTDIR)/plugins/$$f" "$@/Contents/Plugins/`dirname $$f`"; \
	done; \
	#
	@echo
	@echo Writing qt.conf ...
	echo "[Paths]\nPlugins = Plugins" > "$@/Contents/Resources/qt.conf"
	#
	@echo
	@echo Installing Qt Frameworks ...
	for f in $(QT_FRAMEWORKS); do \
		ditto -rsrc "$(QTDIR)/lib/$$f.framework" "$@/Contents/Frameworks/$$f.framework"; \
		rm -rf "$@/Contents/Frameworks/$$f.framework/Headers"; \
		rm -rf "$@/Contents/Frameworks/$$f.framework/$$f""_debug"; \
		rm -rf "$@/Contents/Frameworks/$$f.framework/$$f""_debug.prl"; \
		rm -rf "$@/Contents/Frameworks/$$f.framework/Versions/$(QT_FRAMEWORK_VERSION)/Headers"; \
		rm -rf "$@/Contents/Frameworks/$$f.framework/Versions/$(QT_FRAMEWORK_VERSION)/$$f""_debug"; \
		rm -rf "$@/Contents/Frameworks/$$f.framework/Versions/$(QT_FRAMEWORK_VERSION)/$$f""_debug.prl"; \
		install_name_tool -id "@executable_path/../Frameworks/$$f.framework/Versions/$(QT_FRAMEWORK_VERSION)/$$f" "$@/Contents/Frameworks/$$f.framework/$$f"; \
		for g in $(QT_FRAMEWORKS); do \
			install_name_tool -change "$(QTDIR)/lib/$$g.framework/Versions/$(QT_FRAMEWORK_VERSION)/$$g" "@executable_path/../Frameworks/$$g.framework/Versions/$(QT_FRAMEWORK_VERSION)/$$g" "$@/Contents/Frameworks/$$f.framework/Versions/$(QT_FRAMEWORK_VERSION)/$$f"; \
		done; \
		for g in $(QT_PLUGINS); do \
			install_name_tool -change "$(QTDIR)/lib/$$f.framework/Versions/$(QT_FRAMEWORK_VERSION)/$$f" "@executable_path/../Frameworks/$$f.framework/Versions/$(QT_FRAMEWORK_VERSION)/$$f" "$@/Contents/Plugins/$$g"; \
		done; \
		\# install_name_tool -change "$(QTDIR)/lib/$$f.framework/Versions/$(QT_FRAMEWORK_VERSION)/$$f" "@executable_path/../Frameworks/$$f.framework/Versions/$(QT_FRAMEWORK_VERSION)/$$f" "$@/Contents/Frameworks/libqca.2.dylib"; \
		\# install_name_tool -change "$(QTDIR)/lib/$$f.framework/Versions/$(QT_FRAMEWORK_VERSION)/$$f" "@executable_path/../Frameworks/$$f.framework/Versions/$(QT_FRAMEWORK_VERSION)/$$f" "$@/Contents/Resources/crypto/libqca-openssl.dylib"; \
		install_name_tool -change "$(QTDIR)/lib/$$f.framework/Versions/$(QT_FRAMEWORK_VERSION)/$$f" "@executable_path/../Frameworks/$$f.framework/Versions/$(QT_FRAMEWORK_VERSION)/$$f" "$@/Contents/MacOS/$(EXECUTABLE_NAME)"; \
	done

# The rest
$(DISK_DIR)/%: $(PSI_DIR)/%
	ditto -rsrc "$<" $@


################################################################################
# Disk image creation
################################################################################

WC_DMG=wc.dmg
WC_DIR=wc
TEMPLATE_DMG=template.dmg

$(TEMPLATE_DMG): $(TEMPLATE_DMG).bz2
	bunzip2 -k $<

$(TEMPLATE_DMG).bz2: 
	@echo
	@echo --------------------- Generating empty template --------------------
	mkdir template
	hdiutil create -size 80m "$(TEMPLATE_DMG)" -srcfolder template -format UDRW -volname "$(VOLUME_NAME)" -quiet
	rmdir template
	bzip2 "$(TEMPLATE_DMG)"
	@echo

$(WC_DMG): $(TEMPLATE_DMG)
	cp $< $@

$(MASTER_DMG): $(WC_DMG) $(DISK_FILES)
	@echo
	@echo --------------------- Creating Disk Image --------------------
	mkdir -p $(WC_DIR)
	hdiutil attach "$(WC_DMG)" -noautoopen -quiet -mountpoint "$(WC_DIR)"
	for i in $(DISK_DIR)/*; do  \
		file=`basename $$i`; \
		rm -rf "$(WC_DIR)/$$file"; \
		ditto -rsrc "$(DISK_DIR)/$$file" "$(WC_DIR)/$$file"; \
	done
	#rm -f "$@"
	#hdiutil create -srcfolder "$(WC_DIR)" -format UDZO -imagekey zlib-level=9 "$@" -volname "$(NAME) $(VERSION)" -scrub -quiet
	diskutil eject `diskutil list | grep "$(VOLUME_NAME)" | grep "Apple_HFS" | awk '{print $$6}'`
	rm -f "$(MASTER_DMG)"
	hdiutil convert "$(WC_DMG)" -quiet -format UDZO -imagekey zlib-level=9 -o "$@"
	rm -rf $(WC_DIR)
	-hdiutil internet-enable -yes -quiet "$@"
	@echo

.PHONY: clean-dmg
clean-dmg:
	-rm -rf $(TEMPLATE_DMG) $(MASTER_DMG) $(WC_DMG) $(NAME)-*.dmg

=== src/AutoUpdater/CMakeLists.txt ===
unset(MOC_SOURCES)
unset(HEADERS)
unset(PLAIN_HEADERS)
unset(FORMS)
unset(SOURCES)
unset(PLAIN_SOURCES)
unset(UI_FORMS)

if(WIN32 AND IS_PSIPLUS)
	set(USE_QDCHECKER ON)
endif()

include_directories(
	../
)

list(APPEND PLAIN_HEADERS
	AutoUpdater.h
)

list(APPEND PLAIN_SOURCES
	AutoUpdater.cpp
)

if(APPLE)
	list(APPEND HEADERS
		SparkleAutoUpdater.h
	)
	list(APPEND SOURCES
		SparkleAutoUpdater.mm
	)
	set(EXTRA_LIB
		${SPARKLE_LIBRARY}
	)
endif()

if(USE_QDCHECKER)
	add_definitions(-DUSE_QDCHECKER)
	list(APPEND HEADERS
		QDChecker.h
	)
	list(APPEND PLAIN_SOURCES
		QDChecker.cpp
	)
	list(APPEND FORMS
		QDChangeLog.ui
	)
	include_directories(
		../tools/optionstree
		../widgets
	)
	set(EXTRA_STATIC_LIBS
		tools
		widgets
	)
endif()

qt4_wrap_ui(UI_FORMS ${FORMS})
qt_wrap_cpp(MOC_SOURCES ${HEADERS})
add_library(AutoUpdater STATIC ${HEADERS} ${MOC_SOURCES} ${UI_FORMS} ${PLAIN_SOURCES})
if(USE_QDCHECKER)
	add_dependencies(AutoUpdater build_ui_files tools widgets)
endif()
target_link_libraries(AutoUpdater ${EXTRA_STATIC_LIBS} ${QT_LIBRARIES} ${EXTRA_LIB})
target_include_directories(AutoUpdater PUBLIC ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR})

=== src/Certificates/CMakeLists.txt ===
unset(MOC_SOURCES)
unset(HEADERS)
unset(PLAIN_HEADERS)
unset(FORMS)
unset(SOURCES)
unset(PLAIN_SOURCES)
unset(UI_FORMS)

include_directories(
	${PROJECT_SOURCE_DIR}/iris/include/iris
	${PROJECT_SOURCE_DIR}/iris/src
)

list(APPEND FORMS
	CertificateDisplay.ui
)

list(APPEND HEADERS
	CertificateDisplayDialog.h
	CertificateErrorDialog.h
)

list(APPEND PLAIN_HEADERS
	CertificateHelpers.h
)

list(APPEND PLAIN_SOURCES
	CertificateDisplayDialog.cpp
	CertificateErrorDialog.cpp
	CertificateHelpers.cpp
)

qt4_wrap_ui(UI_FORMS ${FORMS})
qt_wrap_cpp(MOC_SOURCES ${HEADERS})
add_library(Certificates STATIC ${HEADERS} ${MOC_SOURCES} ${UI_FORMS} ${PLAIN_SOURCES})
target_link_libraries(Certificates ${QT_LIBRARIES} ${iris_LIB})
target_include_directories(Certificates PUBLIC ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR})

=== src/avcall/CMakeLists.txt ===
unset(MOC_SOURCES)
unset(HEADERS)
unset(PLAIN_HEADERS)
unset(FORMS)
unset(SOURCES)
unset(PLAIN_SOURCES)
unset(UI_FORMS)

include_directories(
	${PROJECT_SOURCE_DIR}/iris/include/iris
	${PROJECT_SOURCE_DIR}/iris/src
)

add_definitions(-DDEBUG_POSTFIX="")

set(HEADERS
	jinglertptasks.h
	jinglertp.h
	avcall.h
	calldlg.h
)

set(SOURCES
	jinglertp.cpp
	avcall.cpp
	calldlg.cpp
)

set(PLAIN_SOURCES
	jinglertptasks.cpp
)

set(FORMS
	call.ui
)

qt4_wrap_ui(UI_FORMS ${FORMS})
qt_wrap_cpp(MOC_SOURCES ${SOURCES} ${HEADERS})
add_library(avcall STATIC ${SOURCES} ${HEADERS} ${MOC_SOURCES} ${UI_FORMS} ${PLAIN_SOURCES})
add_dependencies(avcall build_ui_files)
target_link_libraries(avcall ${QT_LIBRARIES} ${iris_LIB} libpsi_tools widgets)
target_include_directories(avcall PUBLIC ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR})

=== src/options/CMakeLists.txt ===
unset(MOC_SOURCES)
unset(HEADERS)
unset(PLAIN_HEADERS)
unset(FORMS)
unset(SOURCES)
unset(PLAIN_SOURCES)
unset(UI_FORMS)

include_directories(..)

list(APPEND HEADERS 
	optionsdlg.h
	opt_status.h
	opt_statuspep.h
	opt_toolbars.h
	opt_shortcuts.h
	opt_statusauto.h
	opt_iconset.h
	optionsdlgbase.h
	opt_appearance.h
	opt_advanced.h
	opt_events.h
	opt_popups.h
	opt_roster.h
	opt_groupchat.h
	opt_sound.h
	opt_avcall.h
	opt_chat.h
	optionstab.h
	opt_tree.h
	opt_application.h
	opt_plugins.h
	opt_statusgeneral.h
	opt_theme.h
)

list(APPEND SOURCES

	optionsdlgbase.cpp
	optionstab.cpp
	opt_plugins.cpp
)

list(APPEND PLAIN_SOURCES
	optionsdlg.cpp
	opt_advanced.cpp
	opt_appearance.cpp
	opt_application.cpp
	opt_avcall.cpp
	opt_chat.cpp
	opt_events.cpp
	opt_groupchat.cpp
	opt_iconset.cpp
	opt_popups.cpp
	opt_roster.cpp
	opt_shortcuts.cpp
	opt_sound.cpp
	opt_status.cpp
	opt_statusauto.cpp
	opt_statusgeneral.cpp
	opt_statuspep.cpp
	opt_theme.cpp
	opt_toolbars.cpp
	opt_tree.cpp
)

list(APPEND FORMS 
	opt_advanced.ui
	opt_appearance.ui
	opt_appearance_misc.ui
	opt_application.ui
	opt_avcall.ui
	opt_chat.ui
	opt_events.ui
	opt_general_groupchat.ui
	opt_iconset_activity.ui
	opt_iconset_affiliation.ui
	opt_iconset_client.ui
	opt_iconset_emo.ui
	opt_iconset_mood.ui
	opt_iconset_roster.ui
	opt_iconset_system.ui
	opt_lookfeel_toolbars.ui
	opt_plugins.ui
	opt_popups.ui
	opt_roster.ui
	opt_shortcuts.ui
	opt_sound.ui
	opt_statusauto.ui
	opt_statusgeneral.ui
	opt_statuspep.ui
	opt_theme.ui
	plugininfodialog.ui
	ui_isdetails.ui
	ui_options.ui
)

qt4_wrap_ui(UI_FORMS ${FORMS})
qt_wrap_cpp(MOC_SOURCES ${SOURCES} ${HEADERS})
add_library(options STATIC ${SOURCES} ${HEADERS} ${MOC_SOURCES} ${UI_FORMS} ${PLAIN_SOURCES})
target_link_libraries(options ${QT_LIBRARIES} tools widgets tabs libpsi_dialogs)
target_include_directories(options PUBLIC ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR})

=== src/plugins/CMakeLists.txt ===
cmake_minimum_required( VERSION 2.8.12 )
set_directory_properties(PROPERTIES
	INCLUDE_DIRECTORIES ""
	COMPILE_DEFINITIONS ""
)

if(USE_QT5)
	add_definitions(-DHAVE_QT5)
	set(QT5_BUILD ON)
endif()

option( BUILD_DEV_PLUGINS "Build plugins from dev directory" OFF )

if(EXISTS "${CMAKE_CURRENT_LIST_DIR}/generic")
	set(GENERIC_PLUGINS_FOUND ON)
	message(STATUS "Generic plugins found: ${CMAKE_CURRENT_LIST_DIR}")
else()
	message(FATAL_ERROR "ENABLE_PLUGINS flag is enabled but no generic plugins found at ${CMAKE_CURRENT_LIST_DIR}")
endif()
if(LINUX)
	if(EXISTS "${CMAKE_CURRENT_LIST_DIR}/unix")
		set(UNIX_PLUGINS_FOUND ON)
		message(STATUS "Unix plugins found: ${CMAKE_CURRENT_LIST_DIR}")
	else()
		message(WARNING "ENABLE_PLUGINS flag is enabled but no unix plugins found at ${CMAKE_CURRENT_LIST_DIR}")
	endif()
endif()

if(BUILD_DEV_PLUGINS)
	if(EXISTS "${CMAKE_CURRENT_LIST_DIR}/dev")
		set(DEV_PLUGINS_FOUND ON)
		message(STATUS "Dev plugins found: ${CMAKE_CURRENT_LIST_DIR}")
	else()
		message(WARNING "ENABLE_PLUGINS flag is enabled but no dev plugins found at ${CMAKE_CURRENT_LIST_DIR}")
	endif()
endif()

# Use the same path for shared and static plugins
if(WIN32)
	#Store old runtime output path
	set(OLD_RUNTIME_TARGETS ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
	#Set runtime output path for plugins dll-files
	set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/plugins")
	set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/")
	set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/")
else()
	set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/plugins")
	set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/plugins")
endif()

set(BUILD_PLUGINS "ALL" CACHE STRING "List of plugins to build")

if(NOT "${CMAKE_BUILD_TYPE}" STREQUAL "Debug")
	add_definitions(-DQT_NO_DEBUG )
else()
	add_definitions( -Wall )
endif()

if(NOT WIN32)
	set(LIB_SUFFIX "" CACHE STRING "Define suffix of directory name (32/64)")
	set(PLUGINS_PATH "lib${LIB_SUFFIX}/psi-plus/plugins" CACHE STRING "Install suffix for plugins")
else()
	set(PLUGINS_PATH "psi-plus/plugins" CACHE STRING "Install suffix for plugins")
endif()

if(GENERIC_PLUGINS_FOUND)
	add_subdirectory(generic)
endif()
if(LINUX AND UNIX_PLUGINS_FOUND)
	add_subdirectory(unix)
endif()
if(BUILD_DEV_PLUGINS AND DEV_PLUGINS_FOUND)
	add_subdirectory(dev)
endif()

unset(BUILD_PLUGINS CACHE)
unset(PLUGINS_PATH CACHE)
#Restore default psi-plsu runtime output path
if(WIN32)
	set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${OLD_RUNTIME_TARGETS}")
endif()

=== src/privacy/CMakeLists.txt ===
unset(MOC_SOURCES)
unset(HEADERS)
unset(PLAIN_HEADERS)
unset(FORMS)
unset(SOURCES)
unset(PLAIN_SOURCES)
unset(UI_FORMS)

list(APPEND HEADERS
	privacydlg.h
	privacymanager.h
	privacyruledlg.h
	psiprivacymanager.h
)

list(APPEND PLAIN_HEADERS
	privacylist.h
	privacylistblockedmodel.h
	privacylistitem.h
	privacylistmodel.h
)

list(APPEND SOURCES
	psiprivacymanager.cpp
)

list(APPEND PLAIN_SOURCES
	privacydlg.cpp
	privacylist.cpp
	privacylistblockedmodel.cpp
	privacylistitem.cpp
	privacylistmodel.cpp
	privacyruledlg.cpp
)

list(APPEND FORMS
	privacy.ui
	privacyrule.ui
)

qt4_wrap_ui(UI_FORMS ${FORMS})
qt_wrap_cpp(MOC_SOURCES ${SOURCES} ${HEADERS})
add_library(privacy STATIC ${SOURCES} ${HEADERS} ${SOURCES} ${MOC_SOURCES} ${UI_FORMS} ${PLAIN_SOURCES})
target_link_libraries(privacy ${QT_LIBRARIES} ${iris_LIB} libpsi_tools widgets tabs)
target_include_directories(privacy PUBLIC ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR})

=== src/psimedia/CMakeLists.txt ===
unset(MOC_SOURCES)
unset(HEADERS)
unset(PLAIN_HEADERS)
unset(FORMS)
unset(SOURCES)
unset(PLAIN_SOURCES)
unset(UI_FORMS)

list(APPEND HEADERS
	psimedia.h
)

list(APPEND PLAIN_HEADERS
	psimediaprovider.h
)

list(APPEND SOURCES
	psimedia.cpp
)

add_definitions( -DQT_GUI_LIB )

qt_wrap_cpp(MOC_SOURCES ${SOURCES} ${HEADERS})
add_library(psimedia STATIC ${SOURCES} ${HEADERS} ${MOC_SOURCES} ${UI_FORMS} ${PLAIN_SOURCES})
target_link_libraries(psimedia ${QT_LIBRARIES})
target_include_directories(psimedia PUBLIC ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR})

=== src/sxe/CMakeLists.txt ===
unset(MOC_SOURCES)
unset(HEADERS)
unset(PLAIN_HEADERS)
unset(FORMS)
unset(SOURCES)
unset(PLAIN_SOURCES)
unset(UI_FORMS)
unset(EXTRA_LDFLAGS)

include_directories(${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR})

set(PLAIN_SOURCES
	sxeedit.cpp
	sxemanager.cpp
	sxenewedit.cpp
	sxerecord.cpp
	sxerecordedit.cpp
	sxeremoveedit.cpp
	sxesession.cpp
)

set(HEADERS
	sxemanager.h
	sxerecord.h
	sxesession.h
)

set(PLAIN_HEADERS
	sxeedit.h
	sxenewedit.h
	sxerecordedit.h
	sxeremoveedit.h
)

qt_wrap_cpp(MOC_SOURCES ${HEADERS})
add_library(sxe STATIC ${HEADERS} ${MOC_SOURCES} ${PLAIN_SOURCES} ${PLAIN_HEADERS})
target_link_libraries(sxe ${QT_LIBRARIES} ${iris_LIB} libpsi_tools widgets)

=== debian/changelog ===
psi (1.5+dfsg1-2) unstable; urgency=medium

  * Team upload.
  * Acknowledge NMU.
  * Use libidn-dev instead of libidn11-dev.  Closes: #1086106.

 -- Simon Josefsson <simon@josefsson.org>  Thu, 26 Dec 2024 22:32:41 +0100

psi (1.5+dfsg1-1.1) unstable; urgency=medium

  * Non-maintainer upload.

  [ Chris Lamb ]
  * Make the build reproducible (Closes: #1017473)

 -- Vagrant Cascadian <vagrant@reproducible-builds.org>  Thu, 07 Dec 2023 13:16:09 -0800

psi (1.5+dfsg1-1) unstable; urgency=medium

  * New upstream release.
  * Rewrite debian/watch from scratch.
  * Update files using wrap-and-sort tool.
  * Update debian/control:
    - set Debian XMPP Maintainers as Maintainer
    - move Jan Niehusmann to Uploaders
    - add myself to Uploaders
    - replace build dependency from debhelper (>= 9.0.0) to
      debhelper-compat (= 13)
    - bump Standards-Version to 4.5.1 (was 4.1.1): no changes required
    - add Homepage field
    - add Vcs-Git and Vcs-Browser fields
    - add "Rules-Requires-Root: no"
    - add libqt5sql5-sqlite and libsasl2-modules to Depends of package psi
    - move psi-translations from Suggests to Recommends of package psi
    - update short description of binary package psi
    - update detailed description of binary package psi
    - replace build dependency from qconf to cmake
  * Delete debian/compat.
  * Rewrite debian/rules from scratch:
    - use cmake build system
    - use all hardening flags
  * Remove extra files:
    - debian/README.Debian
    - debian/README.chinese_fonts
    - debian/dirs
    - debian/psi.xpm
    - debian/source/lintian-overrides
    - debian/source/options
    - debian/source/patch-header
  * Update debian/psi.lintian-overrides.
  * Update debian/docs.
  * Add debian/upstream/metadata.
  * Add patch 01_install-hicolor-icons.
  * Rename debian/docs to debian/psi.docs.
  * Remove trailing whitespaces in debian/changelog.
  * Rewrite debian/copyright from scratch using copyright-format/1.0.

 -- Boris Pek <tehnick@debian.org>  Wed, 03 Feb 2021 23:58:48 +0300

psi (1.3-7) unstable; urgency=medium

  * Fix FTBFS with Qt 5.15 (Closes: Bug#975122)

 -- Jan Niehusmann <jan@debian.org>  Thu, 19 Nov 2020 21:54:46 +0100

=== debian/control ===
Source: psi
Section: net
Priority: optional
Maintainer: Debian XMPP Maintainers <pkg-xmpp-devel@lists.alioth.debian.org>
Uploaders: Jan Niehusmann <jan@debian.org>, Boris Pek <tehnick@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 13),
               libaspell-dev,
               libhunspell-dev,
               libidn-dev,
               libminizip-dev,
               libqca-qt5-2-dev,
               libqt5svg5-dev,
               libqt5x11extras5-dev,
               libsm-dev,
               libxss-dev,
               qtbase5-dev,
               qtbase5-dev-tools,
               qtmultimedia5-dev,
               zlib1g-dev
Homepage: https://psi-im.org/
Vcs-Git: https://salsa.debian.org/xmpp-team/psi.git
Vcs-Browser: https://salsa.debian.org/xmpp-team/psi
Standards-Version: 4.5.1
Rules-Requires-Root: no

Package: psi
Architecture: any
Recommends: psi-l10n | psi-translations, sox
Depends: libqca-qt5-2-plugins,
         libqt5sql5-sqlite,
         libsasl2-modules,
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: xdg-utils
Description: Qt-based XMPP client
 Psi is a cross-platform powerful XMPP client designed for experienced users.
 User interface of program is very flexible in customization. For example,
 there are "multi windows" and "all in one" modes, support of different
 iconsets and themes. Psi supports file sharing and audio/video calls. Security
 is also a major consideration, and Psi provides it for both client-to-server
 (TLS) and client-to-client (OpenPGP, OTR, OMEMO) via appropriate plugins.
 .
 Psi+ is a development branch of Psi with rolling release development model.
 Users who wants to receive new features and bug fixes very quickly may use
 Psi+ on daily basis. Users who do not care about new trends and prefer
 constancy may choose Psi as it uses classical development model and its
 releases are quite rare.
 .
 List of supported XEPs you may found at:
 https://github.com/psi-im/psi/wiki/Supported-XEPs

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

PLUGINS_SDK_DIR=$(CURDIR)/debian/psi/usr/share/psi/plugins/

CMAKEOPTS = -DBUNDLED_IRIS=ON \
            -DENABLE_PLUGINS=OFF \
            -DENABLE_WEBKIT=OFF \
            -DINSTALL_EXTRA_FILES=ON \
            -DINSTALL_PLUGINS_SDK=ON \
            -DPRODUCTION=OFF \
            -DUSE_CCACHE=ON \
            -DUSE_DBUS=ON \
            -DUSE_ENCHANT=OFF \
            -DUSE_HUNSPELL=ON \
            -DUSE_KEYCHAIN=OFF \
            -DUSE_WEBENGINE=OFF \
            -DUSE_XSS=ON \
            -DVERBOSE_PROGRAM_NAME=OFF

%:
	dh $@ --buildsystem=cmake

override_dh_dwz:
	dh_dwz || true

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKEOPTS)

override_dh_auto_install:
	dh_auto_install
	mkdir -p $(PLUGINS_SDK_DIR)
	cp -a src/plugins/include $(PLUGINS_SDK_DIR)
	cp -a src/plugins/*.pri $(PLUGINS_SDK_DIR)
